<?php
class SeoBoosterList extends WP_List_Table
{
    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
	 public $site_key;
	 
	function set_key($site_key) {
        $this->site_key = $site_key;
    }
    public function prepare_items()
    {
        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();

        $data = $this->table_data();
        usort( $data, array( &$this, 'sort_data' ) );

        $perPage = 100;
        $currentPage = $this->get_pagenum();
        $totalItems = count($data);

        $this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
        ) );

        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);

        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;
    }

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns()
    {
        $columns = array(
            'id'          => 'ID',
            'title'       => 'Title',
            'permalink' => 'Permalink',
			'options'=>'Options');

        return $columns;
    }
	

	function column_options($item){
		
	
		
		return sprintf('
			<form method="POST" action="'.admin_url( 'admin.php' ).'">
			<input type="hidden" name="action" value="addtonetwork" />	
			<input type="hidden" name="page_id" value="%s" />
			<input type="text" name="post_title" value="%s" />
			<input type="hidden" name="post_permalink" value="%s" />
			<input type="hidden" name="post_type" value="%s" />
			<button  type="submit"  class="button button-primary ">Add to Network</button>
		</form>
			',$item['id'],
			$item['keywords'],
			$item['permalink'],
			$item['post_type']
		);
		
	}

    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns()
    {
        return array();
    }

    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns()
    {
        return array('title' => array('title', false));
    }

    /**
     * Get the table data
     *
     * @return Array
     */
    private function table_data()
    {
			 $data = array();

			$the_query = new WP_Query( array('post_type' => 'any', 'posts_per_page' => '-1', 'post_status' => 'publish' ) );
			
		while ( $the_query->have_posts() ) {
				
				$the_query->the_post();			 
			
			$data[] = array(
                    'id'          => get_the_ID(),
                    'title'       => get_the_title(),
					'post_type'       => get_post_type( get_the_ID() ),
                    'permalink' => get_permalink( get_the_ID() ),
                    'keywords'        => get_the_title()
                    );
		}
		
       
        return $data;
    }

    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            case 'id':
            case 'title':
            case 'permalink':
            case 'keywords':
            case 'keywords_idea':        
                return $item[ $column_name ];

            default:
                return print_r( $item, true ) ;
        }
    }

    /**
     * Allows you to sort the data by the variables set in the $_GET
     *
     * @return Mixed
     */
    private function sort_data( $a, $b )
    {
        // Set defaults
        $orderby = 'title';
        $order = 'asc';

        // If orderby is set, use this as the sort column
        if(!empty($_GET['orderby']))
        {
            $orderby = $_GET['orderby'];
        }

        // If order is set use this as the order
        if(!empty($_GET['order']))
        {
            $order = $_GET['order'];
        }


        $result = strcmp( $a[$orderby], $b[$orderby] );

        if($order === 'asc')
        {
            return $result;
        }

        return -$result;
    }
}

class SeoBoosterListActive extends WP_List_Table
{
    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
	 public $site_key;
	 
	function set_key($site_key) {
        $this->site_key = $site_key;
    }
    public function prepare_items()
    {
        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();

        $data = $this->table_data();
        usort( $data, array( &$this, 'sort_data' ) );

        $perPage = 10;
        $currentPage = $this->get_pagenum();
        $totalItems = count($data);

        $this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
        ) );

        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);

        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;
    }

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns()
    {
        $columns = array(
            'id'          => 'ID',          
            'permalink' => 'Permalink',
            'keywords'        => 'Keywords',
            'keywords_idea'    => 'Keywords ideas',
			'options'=>'Options');

        return $columns;
    }
	function column_keywords($item) {
				
		return sprintf('
			<form method="POST" action="'.admin_url( 'admin.php' ).'">
			<input type="hidden" name="action" value="updatekeywords" />	
			<input type="hidden" name="page_id" value="%s" />
			<input type="text" name="post_title" value="%s" />
			
		
			<button  type="submit"  class="button button-primary ">Update</button>
		</form>
			',$item['id'],
			$item['keywords']
		);
	}

	function column_options($item){
		
		if($item['backlink_status'] =='active'){
			return sprintf(
			'<form method="POST" action="'.admin_url( 'admin.php' ).'">
			<input type="hidden" name="action" value="removefromnetwork" />	
			<input type="hidden" name="page_id" value="%s" />
		
			<button  type="submit"  class="button remove_from_network">Remove</button>
		</form>
			',
			$item['id']
			);
		}else{
			return sprintf(
			'
			<form method="POST" action="'.admin_url( 'admin.php' ).'">
			<input type="hidden" name="action" value="updatetonetwork" />	
			<input type="hidden" name="page_id" value="%s" />
		
			<button  type="submit"  class="button button-primary update_to_network">Add to Network</button>
		</form>
		',
			$item['id']
			);
		}
		
		
	}

    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns()
    {
        return array();
    }

    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns()
    {
        return array('title' => array('title', false));
    }

    /**
     * Get the table data
     *
     * @return Array
     */
    private function table_data()
    {
			 $data = array();

	

			 $remote = wp_remote_get(
					'https://originten.co.uk/plugins/get_social_links.php?site_id='. $this->site_key,
					array(
						'timeout' => 10,
						'headers' => array(
							'Accept' => 'application/json'
						)
					)
				);
				
				if(
					is_wp_error( $remote )
					|| 200 !== wp_remote_retrieve_response_code( $remote )
					|| empty( wp_remote_retrieve_body( $remote ) )
				) {
					return false;
				}
				$remote = json_decode( wp_remote_retrieve_body( $remote ) );
				
				foreach($remote as $socialUrlKey=>$socialUrlVal){
					$data[] = array(
                    'id'          => $socialUrlVal->page_id,                    
                    'permalink' => $socialUrlVal->post_permalink,
                    'keywords'        => $socialUrlVal->post_title,
					 'backlink_status'        => $socialUrlVal->backlink_status,
                    'keywords_idea'    => $socialUrlVal->keywords_idea
                    );
					
				}
		
		
       
        return $data;
    }

    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            case 'id':
            case 'title':
            case 'permalink':
            case 'keywords':
            case 'keywords_idea':        
                return $item[ $column_name ];

            default:
                return print_r( $item, true ) ;
        }
    }

    /**
     * Allows you to sort the data by the variables set in the $_GET
     *
     * @return Mixed
     */
    private function sort_data( $a, $b )
    {
        // Set defaults
        $orderby = 'permalink';
        $order = 'asc';

        // If orderby is set, use this as the sort column
        if(!empty($_GET['orderby']))
        {
            $orderby = $_GET['orderby'];
        }

        // If order is set use this as the order
        if(!empty($_GET['order']))
        {
            $order = $_GET['order'];
        }


        $result = strcmp( $a[$orderby], $b[$orderby] );

        if($order === 'asc')
        {
            return $result;
        }

        return -$result;
    }
}